'----------------------------------------------------------------------------
' 8253dlay.bas                                                       st'00
' * Erzeugen eines Delays mit einer Auflsung von 1 Millisekunde
' * durch Programmierung des Programmierbaren-Intervall-Timers (PIT) 8253.
' * Auflsungen von ca. 1 Mikrosekunde theoretisch mglich.
' * Maximale Delayzeit knapp 55 Millisekunden.
' * Unabhngig von der Rechnergeschwindigkeit.
' * Public Domain
' * INTERNET: http://home.arcor.de/steini63
'----------------------------------------------------------------------------

DECLARE SUB MDummy ()           'Dummy-SUB mit gleichen Anweisungen wie MDelay
DECLARE SUB MDelay (Ziel&)      'erzeugt den Delay
DECLARE FUNCTION MKalibrier& () 'ermittelt Zeitbedarf vom MDummy

CLS
PRINT " Millisekunden-Delay mit  PIT 8253 - Zhler 0 -                        st'00"
PRINT " ----------------------------------------------"
PRINT "  Bitte unter DOS oder im DOS-Modus ausfhren!"
PRINT " ----------------------------------------------"
Anzahl% = 3000   'Anzahl der Schleifen, mit denen MDelay getestet werden soll
Ziel& = 64342    '8253-Timer Zielwert; es wird von 65535 abwrts gezhlt, pro
                 'Millisekunde werden 1193,19 Tics gezhlt (65536 / 54,92549 )
MKal& = MKalibrier&  'Zeitbedarf der SUB ermitteln

PRINT
PRINT Anzahl%; "- facher MDelay von 1 ms ="; Anzahl% * .001; "Sekunden"
PRINT
PRINT " * WERTE DER MDELAY-SCHLEIFE VOR KALIBRIERUNG"
PRINT USING " Dauer einer Schleife in 8253-Tics           =######"; 65535 - Ziel&
PRINT USING " Dauer einer Schleife in Mikrosekunden       =######"; (65535 - Ziel&) * .8380965
PRINT USING " MDelay-Schleife wrde laufen von 65535 bis   ######"; Ziel&
PRINT " * WERTE DER KALIBRIERUNG"
PRINT USING " Eigener Zeitbedarf der SUB in 8253-Tics     =######"; MKal&
PRINT USING " Eigener Zeitbedarf der SUB in Mikrosekunden =######"; MKal& * .8380965

Ziel& = Ziel& + MKal&   'Ziel-Zhlerstand um Wert der Kalibrierung ndern

PRINT " * WERTE DER MDELAY-SCHLEIFE NACH KALIBRIERUNG"
PRINT USING " Dauer einer Schleife in 8253-Tics           =######"; 65535 - Ziel&
PRINT USING " Dauer einer Schleife in Mikrosekunden       =######"; (65536 - Ziel&) * .8380965
PRINT USING " MDelay-Schleife luft von 65535 bis          ######"; Ziel&
PRINT
PRINT " MDelay luft, bitte warten ... "

Ti1 = TIMER
FOR i% = 1 TO Anzahl%
 CALL MDelay(Ziel&)
NEXT

LOCATE 20, 1
PRINT " F E R T I G                   "
PRINT
PRINT USING " Zeitverbrauch laut Funktion TIMER =     #####.## Sek"; TIMER - Ti1
PRINT " (... luft leider whrend der Messungen nicht weiter)"
END

SUB MDelay (Ziel&)
OUT (&H43), 52
OUT (&H40), 255
OUT (&H40), 255
DO
OUT (&H43), 0
a& = INP(&H40)
b& = INP(&H40)
t& = a& + b& * 256
LOOP UNTIL t& <= Ziel&
EXIT SUB
'Kommentare separat, weil sie die Ausfhrung im Interpretermodus verlangsamen
'ebenso Leerzeilen/Leerzeichen. Folgendes passiert in den vorstehenden Zeilen
'52 = &b00110100 8253/Timer0 auf Modus 2 setzen
'Startwert LowByte setzen
'Startwert HighByte setzen
'Schleife starten
'Werte 8253-intern speichern (Counter Latch)
'LowByte lesen
'HighByte lesen
'Bytes nach Wertigkeit summieren
'Schleife wiederholen, bis Zielwert erreicht
'SUB verlassen
END SUB

SUB MDummy
OUT (&H43), 0
OUT (&H43), 0
OUT (&H43), 0
DO
OUT (&H43), 0
a& = INP(&H40)
b& = INP(&H40)
t& = a& + b& * 256
LOOP UNTIL t& <= 66666
EXIT SUB
'Diese vorstehenden Anweisungen machen nichts.
'Die Abfolge ist identisch mit der SUB MDelay.
'Zweck ist es, den Zeitverbrauch zu messen.
'Der Zeitverbrauch in 8253-Tics wird von der
'FUNCTION MKalibrier geliefert.
END SUB

FUNCTION MKalibrier&
'misst den Zeitverbrauch der Anweisungen der SUB MDummy und
'liefert einen Wert in 8253-Tics

FOR i% = 1 TO 2         '2 Durchlufe; der erste Wert ist immer zu hoch
 OUT (&H43), 52         '&b00110100 8253/Timer0 auf Modus 2 setzen
 OUT (&H40), 255        'Startwert LowByte setzen
 OUT (&H40), 255        'Startwert HighByte setzen
 CALL MDummy            'Dummy-Anweisungen starten
 OUT (&H43), 0          'Werte intern speichern (Counter Latch)
 a& = INP(&H40)         'LowByte lesen
 b& = INP(&H40)         'HighByte lesen
 t& = a& + b& * 256     'Bytes nach Wertigkeit summieren
 t& = 65535 - t&        'Zeitbedarf in 8253-Tics
 MKalibrier& = t& * 1.1 '10% Zuschlag fr's Verpassen des richtigen Tics
NEXT

END FUNCTION

